nil = execVM "HOMJ_RoadPainter_GVars.sqf";
// =========================================================================================================
// Initialize functions (these functions are typically run by button presses or calls in scripts)
DirToPos = compile PreProcessFile "DirToPos.sqf";
HOMJ_RoadPainter_MouseMove = compile preprocessfile "func\HOMJ_RoadPainter_MouseMove.sqf";
HOMJ_RoadPainter_FindSelectedKeypart = compile preprocessfile "func\HOMJ_RoadPainter_FindSelectedKeypart.sqf";
HOMJ_RoadPainter_ClickDown = compile preprocessfile "func\HOMJ_RoadPainter_ClickDown.sqf";
HOMJ_RoadPainter_ClickUp = compile preprocessfile "func\HOMJ_RoadPainter_ClickUp.sqf";
HOMJ_RoadPainter_MouseWheel = compile preprocessfile "func\HOMJ_RoadPainter_MouseWheel.sqf";
HOMJ_CullBackslash = compile preprocessfile "func\HOMJ_CullBackslash.sqf";
// Initialize key-handlers for the UI
nil = execVM "func\HOMJ_RoadPainter_KeyHandlers.sqf";

waitUntil {time > 0};

_dlg = createDialog "HOMJ_RoadPainterGUI";
// [_X, _Y], _dir is the "start" point of the drawn road
_X = position player select 0;
_y = position player select 1;
_dir = Direction player;

// Initialize the camera
RoadCam = "camera" camcreate position player;
RoadCam camcommand "inertia off";
RoadCam camPreparePos [_X - 10*sin(_dir), _Y - 10*cos(_dir), 50];
RoadCam setVectorUp [0,0.9,0.1];
RoadCam camCommitPrepared 0;
RoadCam CameraEffect ["internal", "back"];
showCinemaBorder false;

setViewDistance 2000;

// Initialize global variables and listbox entries
nil = execVM "HOMJ_RoadPainter_GVars.sqf";
[] execVM "scripts\HOMJ_RoadPainter_LbRoadTypes.sqf";

// Initialize background-scripts (these scripts run continuously throughout the operation of the program)
[] execVM "scripts\HOMJ_RoadPainter_GUIShowSection.sqf";
[] execVM "scripts\HOMJ_RoadPainter_GUIShowKeyparts.sqf";
[] execVM "scripts\HOMJ_RoadPainter_GUIUpdate.sqf";

// Test and debug stuff