// Get currently selected section name:
private ["_exportSection", "_dims", "_exportThis"];

_h = 0;
{
	call compile format ["_exportSection = + %1", _x];
	//call compile format ["ctrlSetText [10101, str(%1)]", lbData [19873, lbCurSel 19873]];
	// Process road section into exportable data:		["|", "ca\roads2\asf1_",  [0, 6.25], "", [[x, y], dir], [[x, y], dir], _road];

	_i = 0;
	_str = 0;
	_prefix = "";
	_suffix = "";
	
	// First, go through the entire exported section and evaluate it for multiple straight pieces (convert 6+6 to 12, or 6+6+6+6 to 25)
	while {_i < (count _exportSection)} do {
		_road = _exportSection select _i;	
		if (((_road select 0) == "|") AND ((_road select 1 == _prefix) OR (_str == 0))) then {
			if (_str == 0) then {
				_prefix = _road select 1;
				_suffix = _road select 3;
			};
			_str = _str + 1; 
		} else { // If you hit a new road type (not straight or new prefix), then check if there were 2 straights
			if (_str >= 2) then {
				_newRoad = ["|", _prefix, [0, 12.5], _suffix];
				_exportSection set [_i - (_str), _newRoad]; // replace the first straight piece with a 12m section
				_exportSection set [_i - 1, "DELETE"]; // delete the last straight piece
			};
			_str = 0;
		};

		// If it finds 4 straights, then replace with a 25m piece
		if (_str == 4) then {
			_newRoad = ["|", _prefix, [0, 25], _suffix];
			_exportSection set [_i - 3, _newRoad];
			for "_j" from (_i - 2) to (_i) do {
				_exportSection set [_j, "DELETE"];
			};
			_str = _str - 4;
		};

		// If at the end of the road, then check if there are 2 straights
		if ((_i == (count _exportSection - 1)) AND (_str >= 2))then {
			_newRoad = ["|", _prefix, [0, 12.5], _suffix];
			_exportSection set [_i - (_str - 1), _newRoad];
			_exportSection set [_i, "DELETE"];
		};

		_i = _i + 1;
	};
	_exportSection = _exportSection - ["DELETE"];

	
	// Now prepare a data export string
	_exportData = "";
	for "_i" from 0 to (count _exportSection - 1) do {
		_x = _exportSection select _i;

		if ((_x select 0) == "|") then {
			_dims = str(floor ((_x select 2) select 1));
		} else {
			_dims = str(floor ((_x select 2) select 0)) + " " + str(floor ((_x select 2) select 1));
		};
		_exportData = _exportData + (_x select 0) + " " + (_x select 1) + _dims + "^";
	};
	_fileName = toArray (_this select _h);
	for "_i" from 0 to 9 do {_fileName set [_i, "DELETE"];};
	_fileName = toString(_fileName - ["DELETE"]);
	_pathName = ctrlText 19871;
	_export = (format ['HOMJ_PAINTER^WRITE^%1%2.txt^', _pathName, _fileName]) + _exportData;
	copyToClipboard _export;
	waitUntil {sleep 0.01;copyFromClipboard == "HOMJ_ENDWRITE"};
	_h = _h + 1;
} forEach _this;

["EXPORT DONE!"] execVM "scripts\HOMJ_RoadPainter_ThrowMessage.sqf";
sleep 3;
[""] execVM "scripts\HOMJ_RoadPainter_ThrowMessage.sqf";